__author__ = 'tanshu'
from PyQt5 import uic, QtCore, QtWidgets


file = '/home/tanshu/Programming/summer/summer/QtDesignerFiles/ListForm.ui'
base, form = uic.loadUiType(file)


class RoleList(base, form):
    def __init__(self, router, roles, parent=None):
        super(RoleList, self).__init__()
        self.setupUi(self)
        self.translateUi()
        self.router = router
        self.roles = roles
        self.model = RolesTableModel(roles)
        self.tblItems.setModel(self.model)
        self.tblItems.doubleClicked.connect(self.show_role)
        self.btnAddNew.clicked.connect(self.add_new_role)
        self.setAttribute(QtCore.Qt.WA_DeleteOnClose, True)
        self.tblItems.setSelectionBehavior(QtWidgets.QAbstractItemView.SelectRows)

    def translateUi(self):
        self.setObjectName("RoleList")
        _translate = QtCore.QCoreApplication.translate
        self.setWindowTitle(_translate("ListForm", "Roles"))
        self.btnAddNew.setText(_translate("ListForm", "Add Role"))

    def update_data(self, data):
        self.roles = data
        self.model = RolesTableModel(self.roles)
        self.tblItems.setModel(self.model)

    def show_role(self, index):
        role = self.model.roles[index.row()]
        self.router.show_role(role['RoleID'])

    def add_new_role(self):
        self.router.show_role(None)


class RolesTableModel(QtCore.QAbstractTableModel):
    def __init__(self, roles=None, parent=None):
        QtCore.QAbstractTableModel.__init__(self, parent)
        self.roles = roles if roles is not None else []

    def rowCount(self, parent):
        return len(self.roles)

    def columnCount(self, parent):
        return 2

    def data(self, index, role):
        if role == QtCore.Qt.DisplayRole:
            item = self.roles[index.row()]
            column = index.column()
            if column == 0:
                return item['Name']
            elif column == 1:
                return ", ".join(item['Permissions'])

    def headerData(self, section, orientation, role):
        if role == QtCore.Qt.DisplayRole:
            if orientation == QtCore.Qt.Horizontal:
                if section == 0:
                    return 'Name'
                elif section == 1:
                    return 'Permissions'
            else:
                return section + 1
